
' ===========================================================================
' Open-Maxi konfigurieren (NV-Variablen im FLASH-Speicher programmieren)
' In OCBASIC 1.09eee von Dietmar Harlos am 23. Oktober 2012
' letztes Update (Versionsabfrage): am 30. April 2013
' ===========================================================================

' ACHTUNG: Dieses Programm programmiert die letzte FLASH-Page der Open-Maxi.
' Bei diesem sensiblen Vorgang darf nicht die Stromversorgung unterbrochen
' oder ein Reset ausgelst werden! Ansonsten kann die Open-Maxi Schaden
' nehmen und ist nicht mehr zu gebrauchen.

' ---------------------------------------------------------------------------

' An dieser Stelle knnen die diversen Konfigurationen durchgefhrt werden:

' Internal Pullup Enable (PTAPE bis PTGPE)

DEFINE NVPTAPE  &b11111111    ' BYTEPORT[1]
DEFINE NVPTBPE  &b11111111    ' BYTEPORT[2]
DEFINE NVPTCPE  &b11111111    ' 0, CTS, RXD, RTS, TXD, (MCLK), SDA, SCL oder BYTEPORT[3]
DEFINE NVPTDPE  &b00000000    ' AD[1] bis AD[8] oder BYTEPORT[4]
DEFINE NVPTEPE  &b11111111    ' BYTEPORT[5]
DEFINE NVPTFPE  &b11111111    ' CTS2, RTS2, DA[2], DA[1], FREQ2, FREQ1, TEST, BEEP1 oder BYTEPORT[6]
DEFINE NVPTGPE  &b11111111    ' 0, EXTAL, XTAL, KEYB, DCFOK, ACTIVE, RUN, START oder BYTEPORT[7]

' System Power Management Status and Control 2 Register (SPMSC2)

DEFINE NVSPMSC2 &b00110101    ' VLVD = 4.3 V +/- 0.1 V, VLVW = 4.3 V +/- 0.1 V
'DEFINE NVSPMSC2 &b00000101    ' VLVD = 2.56 V +/- 0.08 V, VLVW = 2.56 V +/- 0.08 V

' ---------------------------------------------------------------------------

' HINWEIS: Wer den nachfolgenden Programmcode modifiziert und auf diese Weise
' seine Open-Maxi beschdigt, erhlt keinen Ersatz!

INCLUDE "omax.def"

DIM returncode BYTE
DIM w WORD
DEFINE mybuffer &h0300

IF version<>(40 OR &h80) THEN
  WHILE TRUE
    PRINT "Falscher Controller oder falsche Betriebssystemversion!"
    PAUSE 25
  WEND
END IF

FOR w=0 TO 511
  POKE mybuffer+w,PEEK(&hfe00+w)
NEXT w

POKE mybuffer+&h01c0,NVPTAPE
POKE mybuffer+&h01c1,NVPTBPE
POKE mybuffer+&h01c2,NVPTCPE
POKE mybuffer+&h01c3,NVPTDPE
POKE mybuffer+&h01c4,NVPTEPE
POKE mybuffer+&h01c5,NVPTFPE
POKE mybuffer+&h01c6,NVPTGPE
POKE mybuffer+&h01ca,NVSPMSC2

FOR w=0 TO 511 : IF PEEK(mybuffer+w)=PEEK(&hfe00+w) THEN NEXT w

IF w=511 THEN
  WHILE TRUE
    PRINT "Das Konfigurieren ist nicht notwendig, da keine Aenderungen!"
    PAUSE 25
  WEND
ELSE
  PRINT "Ich programmiere die letzte FLASH-Page. Den Controller nicht unterbrechen!"
END IF

returncode=&hff
SYS &h0900

IF returncode<>0 THEN
  WHILE TRUE
    PRINT "Es ist der Fehler Nummer 1 aufgetreten."
    PAUSE 25
  WEND
END IF

FOR w=0 TO 511 : IF PEEK(mybuffer+w)=PEEK(&hfe00+w) THEN NEXT w

WHILE TRUE
  IF w=511 THEN
    PRINT "Alles okay! Sie koennen die Open-Maxi jetzt resetten."
  ELSE
    PRINT "Es ist der Fehler Nummer 2 bei "w" aufgetreten."
  END IF
  PAUSE 25
WEND

END

' ---------------------------------------------------------------------------

' SYSCODE einbinden

SYSCODE "syscode.s19"
